import static groovyx.gpars.GParsPool.withPool

def getPizza() {
  println "Getting Pizza"
  Thread.sleep(2000)
  "Pizza is here..."
}

def getDrinks() {
  println "Getting drinks"
  Thread.sleep(2000)
}

Time.code {
  //Party sequantial
  def result = getPizza()
  getDrinks()
  println result
}

Time.code {
  //Party concurrent
  def th1 = Thread.start { getPizza() }
  getDrinks()
  th1.join()
  //How to get the output from getPizza?
}

Time.code {
  //Party concurrent with style
  withPool {
    def asyncBlock = { getPizza() }.async()
    def resultFuture = asyncBlock()
    getDrinks()
    println resultFuture.get()    
  }
}


Time.code {
  //Party concurrent with style
  withPool {
    def resultFuture = { getPizza() }.callAsync()
    getDrinks()
    println resultFuture.get()    
  }
}

Time.code {
  //Party concurrent with style
  withPool {
    def resultFuture = { getPizza() }.callTimeoutAsync(100)
    getDrinks()
    println resultFuture.get()    
  }
}
